local mod = RW:Boss("Lady Deathwhisper", "Icecrown Citadell", "Icecrown Citadell", "The Entryway")
local L

-- 3.3?
if not QueryQuestsCompleted then return end

---------------------
-- Variables

local tDominateDur, tDominateCD
local tBerserk

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Lady Deathwhisper"
		
		L.mana_barrier = GetSpellInfo(70842)
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36855)
	mod:SetWin()
	
	tDominateDur	= self:DurTargetTimer(20, 71289)
	tDominateCD		= self:CDTimer(40, 71289)
	tBerserk		= self:BerserkTimer(600)
end

----------------------
-- Locals

local manaLeft

local function ManaBarrierUpdate()
	local uID = mod:GetUIDFromCID(36855)
	if uID then
		manaLeft = UnitMana(uID) / UnitManaMax(uID)
	end
	return manaLeft
end

----------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Dominate", 71289)
	
	tBerserk:Start()
	self:SendMessage("RW_AddHealthFrame", ManaBarrierUpdate, L.mana_barrier)
	
	manaLeft = 1
end

function mod:Dominate(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tDominateDur:Start(args.dName)
		tDominateCD:Start()
	end
end